function f = master(l, risk_type, sample, type, overlap, iter)
%% Parameters
% l = grid
% risk_type = sample used for computing cutoffs
% sample = sample for overlaps
% type = utility 
% overlap = domains considered for overlap
% iter

if overlap(1) == 1 
    % utility type / iteration / grid / risk types for cutoffs
	fgrid(type, iter, l, risk_type);
end

tstart = tic;

rect = csvread(['../csv/', sample, '.csv']);
data = loadData(rect);

in_sample = (data.wage_avg > 0);      % whole sample

% load grid 
grid.name = ['../grids/',type, '_', risk_type, '_', iter,'.mat'];

%% all domains
if overlap(2) == 1 
	overlap_all_d401k(data, grid, type, iter, in_sample, sample);
end

%% CRRA domains - stdi, ltdi, 401k
if overlap(5) == 1
	overlap_crra_d401k(data, grid, type, iter, in_sample, sample);
end

tend = toc(tstart);

end
