%% check overlaps - all domains
% author: iuliana pascu

function f = overlap_all(data, grid, type, iter, in_sample, sample)
tic;

load(grid.name);

%% compute overlap
size_hi = size(grid.l_hi,2);
size_dental = size(grid.l_dental,2);
size_rx = size(grid.l_rx,2);
size_std = size(grid.l_std, 2);
size_ltd = size(grid.l_ltd, 2);
size_fin = size(grid.l_fin, 2);

%total size
[size_hi,size_dental,size_rx,size_ltd,size_std,size_fin]

N = sum(in_sample)
count = 0;

result = zeros(size_hi*size_rx*size_dental*size_std*size_ltd*size_fin, 7);

for k_d = 1:size_dental
    cutoffs_dental = grid.dental.cutoffs{k_d};
    ival.dental(:,1) = cutoffs_dental(sub2ind(size(cutoffs_dental),grid.dental.menu,data.dental.choice));
    ival.dental(:,2) = cutoffs_dental(sub2ind(size(cutoffs_dental),grid.dental.menu,data.dental.choice+1));
    for k_rx = 1:size_rx
        cutoffs_rx = grid.rx.cutoffs{k_rx};
        ival.rx(:,1) = cutoffs_rx(sub2ind(size(cutoffs_rx),grid.rx.menu,data.rx.choice));
        ival.rx(:,2) = cutoffs_rx(sub2ind(size(cutoffs_rx),grid.rx.menu,data.rx.choice+1));
        for k_std = 1:size_std
            cutoffs_std = grid.std.cutoffs{k_std};
            ival.std(:,1)= cutoffs_std(sub2ind(size(cutoffs_std),grid.std.menu,data.std.choice));
            ival.std(:,2)= cutoffs_std(sub2ind(size(cutoffs_std),grid.std.menu,data.std.choice+1));
            for k_ltd = 1:size_ltd
                cutoffs_ltd = grid.ltd.cutoffs{k_ltd};
                ival.ltd(:,1)= cutoffs_ltd(sub2ind(size(cutoffs_ltd),grid.ltd.menu,data.ltd.choice));
                ival.ltd(:,2)= cutoffs_ltd(sub2ind(size(cutoffs_ltd),grid.ltd.menu,data.ltd.choice+1));
                for k_hi=1:size_hi
                    cutoffs_hi = grid.hi.cutoffs{k_hi};
                    ival.hi(:,1) = cutoffs_hi(sub2ind(size(cutoffs_hi),grid.hi.menu,data.hi.choice));
                    ival.hi(:,2) = cutoffs_hi(sub2ind(size(cutoffs_hi),grid.hi.menu,data.hi.choice+1));
                    
                    for k_fin = 1:size_fin
                        cutoffs_fin = grid.fin_disc.cutoffs{1}*grid.l_fin(k_fin);
						ival.fin(:, 1) = cutoffs_fin(sub2ind(size(cutoffs_fin),grid.fin.menu,data.fin.choice));
						ival.fin(:, 2) = cutoffs_fin(sub2ind(size(cutoffs_fin),grid.fin.menu,data.fin.choice+1));
                        count = count + 1;
                        intrsct_lb = max([ival.hi(:,1), ival.dental(:,1), ival.rx(:,1), ival.std(:,1), ival.ltd(:,1), ival.fin(:,1)],[],2);
                        intrsct_ub = min([ival.hi(:,2), ival.dental(:,2), ival.rx(:,2), ival.std(:,2), ival.ltd(:,2), ival.fin(:,2)],[],2);
                        any_overlap = (intrsct_lb<intrsct_ub & in_sample == 1);
                        result(count, :) = [grid.l_hi(k_hi), grid.l_rx(k_rx), grid.l_dental(k_d), grid.l_std(k_std), grid.l_ltd(k_ltd), grid.l_fin(k_fin), sum(any_overlap)/sum(in_sample)];
                    end
                end
            end
        end
    end
end
result


data.all_time = toc;

output_file = ['../results/' type, '_', sample, '_all_', iter]
save(output_file , 'result')

end
