%% check overlaps - crra, cara separately
% author: iuliana pascu

function f = overlap_cara(data, grid, type, iter, in_sample, sample)
tic;

load(grid.name);

size_std = size(grid.l_std, 2);
size_ltd = size(grid.l_ltd, 2);
size_fin = size(grid.l_fin, 2);

count = 0;
result = zeros(size_std*size_ltd*size_fin, 4);
[size_ltd,size_std,size_fin]

for k_std = 1:size_std
    cutoffs_std = grid.std.cutoffs{k_std};
    ival.std(:,1)= cutoffs_std(sub2ind(size(cutoffs_std),grid.std.menu,data.std.choice));
    ival.std(:,2)= cutoffs_std(sub2ind(size(cutoffs_std),grid.std.menu,data.std.choice+1));
    for k_ltd = 1:size_ltd
        cutoffs_ltd = grid.ltd.cutoffs{k_ltd};
        ival.ltd(:,1)= cutoffs_ltd(sub2ind(size(cutoffs_ltd),grid.ltd.menu,data.ltd.choice));
        ival.ltd(:,2)= cutoffs_ltd(sub2ind(size(cutoffs_ltd),grid.ltd.menu,data.ltd.choice+1));
        for k_fin = 1:size_fin
            count = count + 1;
            cutoffs_fin = grid.fin_disc.cutoffs{1}*grid.l_fin(k_fin);
			ival.fin(:, 1) = cutoffs_fin(sub2ind(size(cutoffs_fin),grid.fin.menu,data.fin.choice));
			ival.fin(:, 2) = cutoffs_fin(sub2ind(size(cutoffs_fin),grid.fin.menu,data.fin.choice+1));
            
            intrsct_lb = max([ival.std(:,1), ival.ltd(:,1), ival.fin(:,1)],[],2);
            intrsct_ub = min([ival.std(:,2), ival.ltd(:,2), ival.fin(:,2)],[],2);
            any_overlap = (intrsct_lb<intrsct_ub & in_sample == 1);
            result(count, :) = [grid.l_std(k_std), grid.l_ltd(k_ltd), grid.l_fin(k_fin), sum(any_overlap)/sum(in_sample)];
        end
    end
end

data.all_time = toc;

output_file = ['../results/' type, '_', sample, '_crra_', iter]
save(output_file , 'result')

end
