% August 2011
% author: iuliana pascu

% sample for overlaps
clear all;
rect = csvread(['../csv/base.csv']);
data = loadData(rect);

% type of utility function
typevec{1} = 'cara'
typevec{2}= 'crra';

% first column has sample used for risk type, second has sample for overlaps
samplevec{1,1} = 'base'
samplevec{1,2} = 'base'

samplevec{2,1} = 'base'
samplevec{2,2} = 'housing'

samplevec{3,1} = 'base'
samplevec{3,2} = 'eq50'

samplevec{4,1} = 'base'
samplevec{4,2} = 'eq50_150'

samplevec{5,1} = 'base'
samplevec{5,2} = 'eq150'

samplevec{6,1} = 'base'
samplevec{6,2} = 'max_401k_1'

samplevec{7,1} = 'base'
samplevec{7,2} = 'max_401k_0'

samplevec{8,1} = 'female_1'
samplevec{8,2} = 'female_1'

samplevec{9,1} = 'female_0'
samplevec{9,2} = 'female_0'

samplevec{10,1} = 'young_1'
samplevec{10,2} = 'young_1'

samplevec{11,1} = 'young_0'
samplevec{11,2} = 'young_0'

samplevec{12,1} = 'high_wage_1'
samplevec{12,2} = 'high_wage_1'

samplevec{13,1} = 'high_wage_0'
samplevec{13,2} = 'high_wage_0'

for i = 1:2 		% crra and cara
    for j = 1:13	% different samples
        % use data.wage_avg or data.wage_bal_avg as the alternative measure
        % of income
        income = 'data.wage_avg';
        % sample used to construct cutoffs
        risk_type = samplevec{j,1};
        % sample used as baseline
        sample = samplevec{j,2};
        type = typevec{i};
        overlap = [1,1,1,1,1];  % in order fgrid, all, insurance, cara, crra
        % used to name files
        iter = '_test';
        
        % define grid
        % 		l.hi = 		.02:.15:2;
        % 		l.rx = 		.02:.15:2;
        % 		l.dental = 	.02:.15:2;
        % 		l.std = 	.02:.15:2;
        % 		l.ltd = 	.02:.25:2;
        % 		l.fin = logspace(-2, 6, 5);
        l.hi = 1
        l.rx = 1
        l.dental = 1
        l.std = 1
        l.ltd = 1
        l.fin = 1
        % call with lambda, risk type, sample for overlaps, utility type, overlap to compute, name, income measure
        master(l, risk_type, sample, type, overlap, iter, income);
    end
end
