%% check overlaps - all domains
% december 2010
% author: iuliana pascu

function f = overlap_all(data, grid, iter, in_sample, sample)
tic;

load(grid.name);

%% compute overlap
size_hi = size(grid.l_hi,2);
size_dental = size(grid.l_dental,2);
size_rx = size(grid.l_rx,2);
size_std = size(grid.l_std, 2);
size_ltd = size(grid.l_ltd, 2);
size_fin = size(grid.l_fin, 2);
size_gamma = size(grid.gamma, 2);

%total size
[size_hi,size_dental,size_rx,size_ltd,size_std,size_fin, size_gamma]

N = sum(in_sample)
count = 0;

result = zeros(size_hi*size_rx*size_dental*size_std*size_ltd*size_fin*size_gamma, 8);

for k_g = 1:size_gamma
	for k_d = 1:size_dental
		cutoffs_dental = grid.dental.cutoffs{k_d};
		ival.dental(:,1) = cutoffs_dental(sub2ind(size(cutoffs_dental),grid.dental.menu,data.dental.choice)).*data.wage* grid.gamma(k_g);
		ival.dental(:,2) = cutoffs_dental(sub2ind(size(cutoffs_dental),grid.dental.menu,data.dental.choice+1)).*data.wage* grid.gamma(k_g);
		for k_rx = 1:size_rx
			cutoffs_rx = grid.rx.cutoffs{k_rx};
			ival.rx(:,1) = cutoffs_rx(sub2ind(size(cutoffs_rx),grid.rx.menu,data.rx.choice)).*data.wage* grid.gamma(k_g);
			ival.rx(:,2) = cutoffs_rx(sub2ind(size(cutoffs_rx),grid.rx.menu,data.rx.choice+1)).*data.wage* grid.gamma(k_g);
			for k_hi=1:size_hi
				cutoffs_hi = grid.hi.cutoffs{k_hi};
				ival.hi(:,1) = cutoffs_hi(sub2ind(size(cutoffs_hi),grid.hi.menu,data.hi.choice)).*data.wage* grid.gamma(k_g);
				ival.hi(:,2) = cutoffs_hi(sub2ind(size(cutoffs_hi),grid.hi.menu,data.hi.choice+1)).*data.wage* grid.gamma(k_g);
					
				for k_std = 1:size_std
					cutoffs_std = grid.std.cutoffs{k_std};
					ival.std(:,1)= cutoffs_std(sub2ind(size(cutoffs_std),grid.std.menu,data.std.choice));
					ival.std(:,2)= cutoffs_std(sub2ind(size(cutoffs_std),grid.std.menu,data.std.choice+1));
					for k_ltd = 1:size_ltd
						cutoffs_ltd = grid.ltd.cutoffs{k_ltd};
						ival.ltd(:,1)= cutoffs_ltd(sub2ind(size(cutoffs_ltd),grid.ltd.menu,data.ltd.choice));
						ival.ltd(:,2)= cutoffs_ltd(sub2ind(size(cutoffs_ltd),grid.ltd.menu,data.ltd.choice+1));
						for k_fin = 1:size_fin
							ival.fin = grid.fin.cutoffs*grid.l_fin(k_fin);
							count = count + 1;
							intrsct_lb = max([ival.hi(:,1), ival.dental(:,1), ival.rx(:,1), ival.std(:,1), ival.ltd(:,1), ival.fin(:,1)],[],2);
							intrsct_ub = min([ival.hi(:,2), ival.dental(:,2), ival.rx(:,2), ival.std(:,2), ival.ltd(:,2), ival.fin(:,2)],[],2);
							any_overlap = (intrsct_lb<intrsct_ub & in_sample == 1);
							result(count, :) = [grid.l_hi(k_hi), grid.l_rx(k_rx), grid.l_dental(k_d), grid.l_std(k_std), grid.l_ltd(k_ltd), grid.l_fin(k_fin), grid.gamma(k_g), sum(any_overlap)/sum(in_sample)];
						end
					end
				end
			end
		end
	end
end
result(:, end)

data.all_time = toc;

clear grid

for d = 1:size(result, 2)-1
	grid{d} = unique(result(:,d));
end

% write to file
outfile = ['../output/old_', sample, '_all_', iter '.txt'];
write(outfile, result, grid, sample);

output_file = ['../results/old_', sample, '_all_', iter]
save(output_file , 'result')

end
